## downloadmanager 5.3.69

=== CMakeLists.txt ===
#cmake 最小版本要求
cmake_minimum_required(VERSION 3.1.0)

#工程名
project(downloader)
set(PROJECT_VERSION "5.3.69")
set(PROJECT_VERSION_MAJOR 5)
set(QT_MIN_VERSION "5.11.0")
set(DLM_NAME "downloader")
set(ARIA2_NAME "aria2c")


# 设置C++标准为 C++ 11
set(CMAKE_CXX_STANDARD 11)

#在debug下库名后面加d
set(CMAKE_DEBUG_POSTFIX "d")

#设置安装路径
set(CMAKE_INSTALL_PREFIX /usr)
## Install settings
#if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
#    set(CMAKE_INSTALL_PREFIX /usr)
#endif ()

#option(DOTEST "option for test" OFF)

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
    message("release")
    # generate qm
    execute_process(COMMAND bash "translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif ()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all -z now -z noexecstack -fpie -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all -z now -z noexecstack -fpie -pie")

set(APP_RES_DIR "assets")
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -z noexecstack")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3 -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -z noexecstack")
    SET(CMAKE_EXE_LINKER_FLAGS  "-pie")
endif()
#库 和 执行文件 的设置输出的路径
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

#set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_INSTALL_PREFIX}/lib)
#set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_INSTALL_PREFIX}/lib)
#set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_INSTALL_PREFIX}/bin)

configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h )

message(STATUS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

#包含当前路径，使用*.ui文件时，需要加上这句，否则找不到头文件
set(CMAKE_INCLUDE_CURRENT_DIR ON)
#打开全局moc
set(CMAKE_AUTOMOC ON)
#打开全局rcc，本示例中没有使用qrc
set(CMAKE_AUTORCC ON)
#打开全局uic
set(CMAKE_AUTOUIC ON)

set(QT Core Gui Widgets Network DBus Sql LinguistTools Svg Test WebChannel WebSockets)
find_package(Qt5 COMPONENTS ${QT} REQUIRED)

#应用DTK库
set(DTK Widget Core Gui)
find_package(Dtk COMPONENTS ${DTK} REQUIRED)

#安装
# qm files.
file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES} DESTINATION share/downloader/translations)

#desktop
install(FILES desktop/downloader.desktop DESTINATION share/applications)

#datebases
install(FILES data/downloader.db DESTINATION share/downloader/database)

# conf file
file(GLOB CF_FILES "docs/*.conf")
install(FILES ${CF_FILES} DESTINATION share/downloader/config)
file(GLOB JS_FILES "docs/httpAdvanced.json")
install(FILES ${JS_FILES} DESTINATION share/downloader/config)

#icon
install(FILES data/downloader.svg DESTINATION share/icons/hicolor/scalable/apps/)
install(FILES data/downloader.svg DESTINATION share/downloader/icons/logo/)

# 开启单元测试

# 添加子模块test
add_subdirectory(src)
add_subdirectory(translations)
add_subdirectory(tests)

install(TARGETS downloader dlmlog dlmdatabase dlmaria2 dlmcontrolui
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib
ARCHIVE DESTINATION libstatic
)

install(DIRECTORY ${APP_RES_DIR}/downloader DESTINATION /usr/share/deepin-manual/manual-assets/application/)
install(FILES docs/info.json DESTINATION share/downloader/extension/)
install(FILES docs/ojlicckikdkkaclkpdddijgehekpmmbg.crx DESTINATION share/downloader/extension/)
install(FILES docs/browser.downloader.autostart.json DESTINATION /etc/browser/native-messaging-hosts/)
install(FILES docs/startdlmservice.sh DESTINATION /usr/libexec/openconnect/)

=== src/CMakeLists.txt ===
#加载子模块
add_subdirectory(src)

=== tests/CMakeLists.txt ===
# 设置测试程序名字
set(PROJECT_NAME_TEST
    ${PROJECT_NAME}_test)

#开启moc编译
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

#可访问private
ADD_COMPILE_OPTIONS(-fno-access-control)
ADD_COMPILE_OPTIONS(-fno-inline)
#添加-fno-inline编译选项，禁止内联，能获取到函数地址，可以对内联函数进行打桩
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-inline")

set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

# 添加gocv覆盖率文件的输出
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage")

#test files
AUX_SOURCE_DIRECTORY(. SRC_LIST)
AUX_SOURCE_DIRECTORY(./ MAIN)
LIST(APPEND SRC_LIST ${MAIN})
AUX_SOURCE_DIRECTORY(./aria2 ARIA2)
LIST(APPEND SRC_LIST ${ARIA2})
AUX_SOURCE_DIRECTORY(./database DATABASE)
LIST(APPEND SRC_LIST ${DATABASE})
AUX_SOURCE_DIRECTORY(./log LOG)
LIST(APPEND SRC_LIST ${LOG})
AUX_SOURCE_DIRECTORY(./ui UI)
LIST(APPEND SRC_LIST ${UI})
AUX_SOURCE_DIRECTORY(./ui UI)
LIST(APPEND SRC_LIST ${UI})
AUX_SOURCE_DIRECTORY(./ui/createTask CREATETASK)
LIST(APPEND SRC_LIST ${CREATETASK})
AUX_SOURCE_DIRECTORY(./ui/mainFrame MAINFRAME)
LIST(APPEND SRC_LIST ${MAINFRAME})
AUX_SOURCE_DIRECTORY(./ui/settings SETTINGS)
LIST(APPEND SRC_LIST ${SETTINGS})
AUX_SOURCE_DIRECTORY(./ui/websocket WEBSOCKET)
LIST(APPEND SRC_LIST ${WEBSOCKET})

#源头文件
file(GLOB ALL_HEADERS "./*.h"
                      "../src/include/ui/*.h"
                      "../src/include/aria2/*.h"
                      "../src/include/database/*.h"
                      "../src/include/log/*.h"
                      "../src/include/ui/createTask/*.h"
                      "../src/include/ui/mainFrame/*.h"
                      "../src/include/ui/settings/*.h"
                      "../src/include/ui/websocket/*.h"
                      )
#源文件
file(GLOB ALL_SOURCES "../src/src/ui/*.cpp"
                      "../src/src/aria2/*.cpp"
                      "../src/src/database/*.cpp"
                      "../src/src/log/*.cpp"
                      "../src/src/ui/createTask/*.cpp"
                      "../src/src/ui/mainFrame/*.cpp"
                      "../src/src/ui/settings/*.cpp"
                      "../src/src/ui/websocket/*.cpp"
                      )

#添加资源文件
file(GLOB SRC_QRC ${PROJECT_SOURCE_DIR}/src/src/ui/resource/*.qrc)

#需要生成的moc文件，输出文件名称放在变量 mocfiles中，必须在find QT5 package才能调用
QT5_WRAP_CPP (UDLC_UI_HEADERS_MOC ${ALL_HEADERS})

#将test文件，源文件，源头文件，moc文件加入到test程序中
add_executable(${PROJECT_NAME_TEST} ${SRC_LIST} ${ALL_HEADERS} ${ALL_SOURCES} ${UDLC_UI_HEADERS_MOC} ${SRC_QRC})

#添加gtest库，Qt库，dtk库
target_link_libraries(${PROJECT_NAME_TEST} gmock gmock_main gtest gtest_main pthread
    Qt5::Core Qt5::Network Qt5::Widgets Qt5::Svg Qt5::DBus Qt5::Sql Qt5::Test dtkwidget dtkgui dtkcore Qt5::WebChannel Qt5::WebSockets)

# 添加 QTest 测试
add_test(${PROJECT_NAME_TEST} COMMAND ${PROJECT_NAME_TEST})


#------------------------------ 创建'make test'指令---------------------------------------
add_custom_target(test
    COMMAND echo " =================== TEST BEGIN ==================== "
    COMMAND mkdir -p coverageResult
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_BINARY_DIR}/bin/${PROJECT_NAME_TEST}
    COMMAND echo " =================== TEST END ==================== "
)
#add_custom_command(TARGET test
#COMMAND echo " =================== CREAT LCOV REPROT BEGIN ==================== "
# #1.清理原先的gcov信息
#COMMAND lcov --directory ./CMakeFiles/${PROJECT_NAME_TEST}.dir --zerocounters
#COMMAND lcov --directory ./CMakeFiles/${PROJECT_NAME}.dir --zerocounters
# COMMAND ./bin/${PROJECT_NAME_TEST}
# #2.收集gcov信息到.info文件中
#COMMAND lcov --directory . --capture --output-file ./coverageResult/${PROJECT_NAME}_Coverage.info
# #3.过滤一些我们不感兴趣的文件的覆盖率信息
#COMMAND echo " =================== do filter begin ==================== "
#COMMAND lcov --remove ./coverageResult/${PROJECT_NAME}_Coverage.info
#'*/${PROJECT_NAME_TEST}_autogen/*' '*/${PROJECT_NAME}_autogen/*' '*/usr/include/*' '*/tests/*' '*/googletest/*' '${PROJECT_SOURCE_DIR}/test/*' '${PROJECT_SOURCE_DIR}/src/include/*' '${PROJECT_BINARY_DIR}/*'
#'${PROJECT_SOURCE_DIR}/src/src/ui/createTask/*delegate.cpp'
#-o ./coverageResult/${PROJECT_NAME}_Coverage.info
#COMMAND echo " =================== do filter end ==================== "
# #3.将.info信息生成报告到reprot文件夹中
#COMMAND genhtml -o ./coverageResult/report ./coverageResult/${PROJECT_NAME}_Coverage.info
#COMMAND echo " =================== CREAT LCOV REPROT END ==================== "
#COMMAND echo " Coverage files have been output to ${CMAKE_BINARY_DIR}/coverageResult/report "
#WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
#)

#'make test'命令依赖与我们的测试程序
add_dependencies(test ${PROJECT_NAME_TEST})

#添加头文件
include_directories(${PROJECT_SOURCE_DIR}/src/include/database)
include_directories(${PROJECT_SOURCE_DIR}/src/include/aria2)
include_directories(${PROJECT_SOURCE_DIR}/src/include/ui)
include_directories(${PROJECT_SOURCE_DIR}/src/include/ui/settings)
include_directories(${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame)
include_directories(${PROJECT_SOURCE_DIR}/src/include/ui/createTask)
include_directories(${PROJECT_SOURCE_DIR}/src/include/ui/websocket)
include_directories(${PROJECT_SOURCE_DIR}/src/include/log)
include_directories(${PROJECT_BINARY_DIR})

=== translations/CMakeLists.txt ===
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

=== src/src/CMakeLists.txt ===
#加载子模块
add_subdirectory(log)
#add_subdirectory(monitor)
add_subdirectory(aria2)
add_subdirectory(database)
add_subdirectory(ui)
add_subdirectory(downloader)
add_subdirectory(extensionService)

=== src/src/aria2/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src/include/aria2
                    ${PROJECT_SOURCE_DIR}/src/include/log
                    ${CMAKE_BINARY_DIR}
    )
message(${CMAKE_BINARY_DIR})
message(aria2 123)
link_directories(${CMAKE_BINARY_DIR}/lib)
#SET_TARGET_PROPERTIES(dlmaria2 PROPERTIES VERSION PROJECT_VERSION SOVERSION 1)
#预定义宏，主要用于共享库导出
#ADD_DEFINITIONS(-DARIA_LIB )

#需要moc(加Q_OBJECT)的头文件
set (DWM_ARIA_HEADERS
    ${PROJECT_SOURCE_DIR}/src/include/aria2/aria2rpcinterface.h
)

#需要生成的moc文件，输出文件名称放在变量 mocfiles中，必须在find QT5 package才能调用
QT5_WRAP_CPP (DWM_ARIA_HEADERS_MOC ${DWM_ARIA_HEADERS})

#设置输出dll的名称、类型(动态库、静态库)及所用到的文件
add_library(dlmaria2 SHARED
    aria2rpcinterface.cpp
    aria2cbtinfo.cpp
    ${DWM_ARIA_HEADERS_MOC}
)

target_link_libraries(dlmaria2 dlmlog Qt5::Core)

#install(TARGETS dlmaria2 DESTINATION lib)

=== src/src/database/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src/include/database
                    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame)
link_directories(${CMAKE_BINARY_DIR}/lib)

#预定义宏，主要用于dll导出
ADD_DEFINITIONS(-DLM_DATABASE_LIB )

#需要moc(加Q_OBJECT)的头文件
set (DWM_DATABASE_HEADERS
    ${PROJECT_SOURCE_DIR}/src/include/database/database.h
    ${PROJECT_SOURCE_DIR}/src/include/database/dbinstance.h
    ${PROJECT_SOURCE_DIR}/src/include/database/dbdefine.h
)

#需要生成的moc文件，输出文件名称放在变量 mocfiles中，必须在find QT5 package才能调用
QT5_WRAP_CPP (DWM_DATABASE_HEADERS_MOC ${DWM_DATABASE_HEADERS})

#设置输出dll的名称、类型(动态库、静态库)及所用到的文件
add_library(dlmdatabase SHARED
    database.cpp
    dbinstance.cpp
    ${DWM_DATABASE_HEADERS_MOC}
)

target_link_libraries(dlmdatabase dlmlog Qt5::Core Qt5::Widgets Qt5::Sql)

#install(TARGETS dlmdatabase DESTINATION lib)

=== src/src/downloader/CMakeLists.txt ===
#设置包含目录
include_directories(${PROJECT_SOURCE_DIR}/src/include/ui
                    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame
                    ${PROJECT_SOURCE_DIR}/src/include/ui/settings
                    ${PROJECT_SOURCE_DIR}/src/include/ui/websocket
                    ${PROJECT_SOURCE_DIR}/src/include/log
                    ${PROJECT_SOURCE_DIR}/src/include/downloader
                    ${CMAKE_BINARY_DIR}
)
link_directories(${CMAKE_BINARY_DIR}/lib)

#需要moc(加Q_OBJECT)的头文件
set (DWM_EXTENSIONSERVICE_HEADERS
    ${PROJECT_SOURCE_DIR}/src/include/downlaoder/accessiblewidget.h
)

#设置输入执行文件名称
add_executable(downloader main.cpp
    accessiblewidget.cpp
)

target_link_libraries(downloader dlmcontrolui dlmlog Qt5::Core)

#INSTALL(TARGETS downloader DESTINATION share/downloader)
#install(TARGETS downloader DESTINATION bin)

=== src/src/extensionService/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src/include/extensionService
                    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame)
link_directories(${CMAKE_BINARY_DIR}/lib)

#预定义宏，主要用于dll导出
ADD_DEFINITIONS(-DLM_EXTENSIONSERVICE_LIB )

#需要moc(加Q_OBJECT)的头文件
set (DWM_EXTENSIONSERVICE_HEADERS
    ${PROJECT_SOURCE_DIR}/src/include/extensionService/websocketclientwrapper.h
    ${PROJECT_SOURCE_DIR}/src/include/extensionService/websockethandle.h
    ${PROJECT_SOURCE_DIR}/src/include/extensionService/websockettransport.h
    ${PROJECT_SOURCE_DIR}/src/include/extensionService/extensionservice.h
)

#需要生成的moc文件，输出文件名称放在变量 mocfiles中，必须在find QT5 package才能调用
QT5_WRAP_CPP (DWM_EXTENSIONSERVICE_HEADERS_MOC ${DWM_EXTENSIONSERVICE_HEADERS})

#设置输出dll的名称、类型(动态库、静态库)及所用到的文件
add_executable(dlmextensionservice
    websocketclientwrapper.cpp
    websockettransport.cpp
    websockethandle.cpp
    extensionservice.cpp
    main.cpp
    ${DWM_EXTENSIONSERVICE_HEADERS_MOC}
)

target_link_libraries(dlmextensionservice Qt5::Core Qt5::Widgets Qt5::WebChannel Qt5::WebSockets Qt5::Network Qt5::DBus dtkcore dtkwidget )

install(TARGETS dlmextensionservice DESTINATION bin)

=== src/src/log/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src/include/log)

link_directories(${CMAKE_BINARY_DIR}/lib)

#预定义宏，主要用于dll导出
ADD_DEFINITIONS(-DLM_LOG_LIB )

add_library(dlmlog SHARED
    log.cpp
    )
target_link_libraries(dlmlog Qt5::Core)

#install(TARGETS dlmlog DESTINATION lib)

=== src/src/ui/CMakeLists.txt ===
#设置包含目录
include_directories( ${PROJECT_SOURCE_DIR}/src/include/ui
                     ${PROJECT_SOURCE_DIR}/src/include/aria2
                     ${PROJECT_SOURCE_DIR}/src/include/log
                     ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame
                     ${PROJECT_SOURCE_DIR}/src/include/ui/createTask
                     ${PROJECT_SOURCE_DIR}/src/include/ui/settings
                     ${PROJECT_SOURCE_DIR}/src/include/ui/websocket
                     ${CMAKE_BINARY_DIR}
)

link_directories(${CMAKE_BINARY_DIR}/lib)

#预定义宏，主要用于dll导出
ADD_DEFINITIONS(-DLM_CONTROLUI_LIB )

#需要moc(加Q_OBJECT)的头文件 
set (UDLC_UI_HEADERS
    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame/mainframe.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame/tableView.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame/tableModel.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame/headerView.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame/itemDelegate.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame/topButton.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame/deleteitemthread.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame/tabledatacontrol.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/mainFrame/searchresoultwidget.h

    ${PROJECT_SOURCE_DIR}/src/include/ui/createTask/createtaskwidget.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/createTask/btinfodelegate.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/createTask/btinfodialog.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/createTask/btinfotableview.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/createTask/urlthread.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/createTask/analysisurl.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/createTask/taskdelegate.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/createTask/btheaderview.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/createTask/taskModel.h

    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/notificationssettiingwidget.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/settingswidget.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/downloadsettingwidget.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/filesavepathchooser.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/itemselectionwidget.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/settinginfoinputwidget.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/settings.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/settingslabel.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/diagnostictool.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/httpadvancedsettingwidget.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/settings/timeEdit.h

    ${PROJECT_SOURCE_DIR}/src/include/ui/global.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/messagebox.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/clipboardtimer.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/dlmapplication.h
    ${PROJECT_SOURCE_DIR}/src/include/ui/func.h
)



#发布的时候生成qm文件
#if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
#    #生成 ts qm文件
#    set(TS_FILES  ${PROJECT_SOURCE_DIR}  "${PROJECT_SOURCE_DIR}/translations/downloader_zh_CN.ts")
#    qt5_create_translation(QM_FILES
#        ${PROJECT_SOURCE_DIR}/translations
#        ${TS_FILES}
#        OPTIONS -source-language en_US -no-obsolete)

#    set(TS_FILES  ${PROJECT_SOURCE_DIR}  "${PROJECT_SOURCE_DIR}/translations/downloader_en_US.ts")
#    qt5_create_translation(QM_FILES
#        ${PROJECT_SOURCE_DIR}/translations
#        ${TS_FILES}
#        OPTIONS -source-language en_US -no-obsolete)
#endif ()


#需要生成的moc文件，输出文件名称放在变量 mocfiles中，必须在find QT5 package才能调用
QT5_WRAP_CPP (UDLC_UI_HEADERS_MOC ${UDLC_UI_HEADERS})

#添加资源文件
set(QRC_SOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/resource/resource.qrc)
qt5_add_resources(QRC_FILES ${QRC_SOURCE_FILES})

#设置输出dll的名称、类型(动态库、静态库)及所用到的文件
add_library(dlmcontrolui SHARED
       mainFrame/mainframe.cpp
       mainFrame/tableView.cpp
       mainFrame/tableModel.cpp
       mainFrame/tabledatacontrol.cpp
       mainFrame/headerView.cpp
       mainFrame/itemDelegate.cpp
       mainFrame/topButton.cpp
       mainFrame/deleteitemthread.cpp
       mainFrame/searchresoultwidget.cpp
       createTask/createtaskwidget.cpp
       createTask/btinfodelegate.cpp
       createTask/btinfodialog.cpp
       createTask/btinfotableview.cpp
       createTask/btheaderview.cpp
       createTask/urlthread.cpp
       createTask/analysisurl.cpp
       createTask/taskdelegate.cpp
       createTask/taskModel.cpp
       settings/notificationssettiingwidget.cpp
       settings/settingswidget.cpp
       settings/downloadsettingwidget.cpp
       settings/filesavepathchooser.cpp
       settings/itemselectionwidget.cpp
       settings/settinginfoinputwidget.cpp
       settings/settings.cpp
       settings/settingslabel.cpp
       settings/diagnostictool.cpp
       settings/httpadvancedsettingwidget.cpp
       settings/timeEdit.cpp
       clipboardtimer.cpp
       messagebox.cpp
       dlmapplication.cpp
       func.cpp
       ${UDLC_UI_HEADERS_MOC}
       ${QRC_FILES}
       ${QM_FILES}
)

target_link_libraries(dlmcontrolui dlmlog dlmaria2 dlmdatabase dtkcore  dtkwidget
    Qt5::Core Qt5::Network Qt5::Widgets Qt5::Svg Qt5::DBus)

#install(TARGETS dlmcontrolui DESTINATION lib)

=== debian/changelog ===
downloadmanager (5.3.69-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 25 Mar 2022 17:13:46 +0800

downloadmanager (5.3.69) stable; urgency=medium

  * 升级版本号

 -- zhaoyue <zhaoyue@uniontech.com>  Wed, 16 Feb 2022 14:42:58 +0800

downloadmanager (5.3.67) stable; urgency=medium

  * 修改下载内容的背景色

 -- zhaoyue <zhaoyue@uniontech.com>  Wed, 16 Feb 2022 11:13:29 +0800

downloadmanager (5.3.66) stable; urgency=medium

  * 去掉dlmextensionservice.desktop文件

 -- zhaoyue <zhaoyue@uniontech.com>  Mon, 17 Jan 2022 15:27:27 +0800

downloadmanager (5.3.65) stable; urgency=medium

  * 添加log等级的判断

 -- zhaoyue <zhaoyue@uniontech.com>  Thu, 02 Dec 2021 15:46:38 +0800

downloadmanager (5.3.64) stable; urgency=medium

  * 去掉日志中的下载链接

 -- zhaoyue <zhaoyue@uniontech.com>  Tue, 30 Nov 2021 18:26:14 +0800

downloadmanager (5.3.62) stable; urgency=medium

  * 去掉日志中的下载链接

 -- zhaoyue <zhaoyue@uniontech.com>  Mon, 29 Nov 2021 15:17:40 +0800

downloadmanager (5.3.59) stable; urgency=medium

  * 修改部分bug

 -- zhaoyue <zhaoyue@uniontech.com>  Mon, 08 Nov 2021 11:22:40 +0800

downloadmanager (5.3.58) stable; urgency=medium

  * 修改aria2后台进程会关闭的bug

 -- zhaoyue <zhaoyue@uniontech.com>  Mon, 11 Oct 2021 15:14:56 +0800

downloadmanager (5.3.57) stable; urgency=medium

  * 修改诊断工具显示的bug

 -- zhaoyue <zhaoyue@uniontech.com>  Tue, 28 Sep 2021 16:43:04 +0800

downloadmanager (5.3.55) stable; urgency=medium

  * 修改KLU的bug

 -- zhaoyue <zhaoyue@uniontech.com>  Wed, 22 Sep 2021 10:05:58 +0800

downloadmanager (5.3.52) stable; urgency=medium

  * 修改KLU的bug

 -- zhaoyue <zhaoyue@uniontech.com>  Sun, 19 Sep 2021 15:17:43 +0800

downloadmanager (5.3.50) stable; urgency=medium

  * 去掉运行依赖中的nmap依赖

 -- zhaoyue <zhaoyue@uniontech.com>  Tue, 14 Sep 2021 11:01:30 +0800

downloadmanager (5.3.49) stable; urgency=medium

  * 去掉nmap依赖以及相关代码，删除无用的代码

 -- zhaoyue <zhaoyue@uniontech.com>  Mon, 13 Sep 2021 10:50:57 +0800

downloadmanager (5.3.48) stable; urgency=medium

  * 修改浏览器配置文件保存目录

 -- zhaoyue <zhaoyue@uniontech.com>  Thu, 26 Aug 2021 10:09:59 +0800

downloadmanager (5.3.47) stable; urgency=medium

  * 修改root启动界面显示异常

 -- zhaoyue <zhaoyue@uniontech.com>  Thu, 19 Aug 2021 13:32:44 +0800

downloadmanager (5.3.46) stable; urgency=medium

  * 修改2个bug

 -- zhaoyue <zhaoyue@uniontech.com>  Wed, 18 Aug 2021 21:28:20 +0800

downloadmanager (5.3.45) stable; urgency=medium

  * 修改debian的postinst，将浏览器扩展的配置文件拷贝到浏览器目录下

 -- zhaoyue <zhaoyue@uniontech.com>  Tue, 27 Jul 2021 09:55:28 +0800

downloadmanager (5.3.44) stable; urgency=medium

  * 修改浏览器扩展的安装逻辑

 -- zhaoyue <zhaoyue@uniontech.com>  Thu, 22 Jul 2021 15:13:01 +0800

downloadmanager (5.3.43) stable; urgency=medium

  * 添加libssl依赖包

 -- zhaoyue <zhaoyue@uniontech.com>  Tue, 20 Jul 2021 15:29:24 +0800

downloadmanager (5.3.42) stable; urgency=medium

  * 修改bug

 -- zhaoyue <zhaoyue@uniontech.com>  Thu, 15 Jul 2021 15:50:56 +0800

downloadmanager (5.3.41) stable; urgency=medium

  * 修改解析url时的bug

 -- zhaoyue <zhaoyue@uniontech.com>  Wed, 07 Jul 2021 10:24:17 +0800

downloadmanager (5.3.40) stable; urgency=medium

  * 修改KLU的bug，删除掉主线的依赖

 -- zhaoyue <zhaoyue@uniontech.com>  Thu, 01 Jul 2021 10:36:29 +0800

downloadmanager (5.3.39) stable; urgency=low

  * 添加libssl依赖包

 -- zhaoyue <zhaoyue@uniontech.com>  Fri, 25 Jun 2021 09:23:04 +0800

downloadmanager (5.3.38) stable; urgency=low

  * 修改浏览器扩展的bug

 -- zhaoyue <zhaoyue@uniontech.com>  Wed, 23 Jun 2021 19:19:46 +0800

downloadmanager (5.3.37) stable; urgency=low

  * 修改bug

 -- zhaoyue <zhaoyue@uniontech.com>  Fri, 18 Jun 2021 14:33:20 +0800

downloadmanager (5.3.36) stable; urgency=low

  * 修改新建任务延时

 -- zhaoyue <zhaoyue@uniontech.com>  Wed, 16 Jun 2021 13:20:35 +0800

downloadmanager (5.3.35) stable; urgency=low

  * 修改部分bug

 -- zhaoyue <zhaoyue@uniontech.com>  Mon, 07 Jun 2021 19:09:03 +0800

downloadmanager (5.3.34) stable; urgency=low

  * 修改rpm包的名称

 -- zhaoyue <zhaoyue@uniontech.com>  Thu, 27 May 2021 14:10:14 +0800

downloadmanager (5.3.33) stable; urgency=low

  * 修改获取链接信息的逻辑

 -- zhaoyue <zhaoyue@uniontech.com>  Tue, 25 May 2021 20:22:13 +0800

downloadmanager (5.3.32) stable; urgency=low

  * 修改desktop文件

 -- zhaoyue <zhaoyue@uniontech.com>  Tue, 18 May 2021 15:53:27 +0800

downloadmanager (5.3.31) stable; urgency=low

  * 修改desktop文件

 -- zhaoyue <zhaoyue@uniontech.com>  Fri, 14 May 2021 15:42:38 +0800

downloadmanager (5.3.30) stable; urgency=low

  * 修改单元测试

 -- zhaoyue <zhaoyue@uniontech.com>  Fri, 14 May 2021 13:49:30 +0800

downloadmanager (5.3.29) stable; urgency=low

  * 添加Accessible属性

 -- zhaoyue <zhaoyue@uniontech.com>  Thu, 13 May 2021 14:36:46 +0800

downloadmanager (5.3.28) stable; urgency=low

  * 修改浏览器扩展，修改下载器的安装脚本

 -- zhaoyue <zhaoyue@uniontech.com>  Mon, 10 May 2021 16:51:45 +0800

downloadmanager (5.3.27) stable; urgency=low

  * 修改dbus接口名称

 -- zhaoyue <zhaoyue@uniontech.com>  Tue, 04 May 2021 11:02:50 +0800

downloadmanager (5.3.26) stable; urgency=low

  * 修改desktop文件名

 -- zhaoyue <zhaoyue@uniontech.com>  Fri, 30 Apr 2021 14:39:30 +0800

downloadmanager (5.3.25) stable; urgency=low

  * 重构浏览器扩展部分，添加新的进程dlmextensionservice

 -- zhaoyue <zhaoyue@uniontech.com>  Fri, 30 Apr 2021 11:28:10 +0800

downloadmanager (5.3.24) stable; urgency=low

  * 修改带参数的http链接的解析方式

 -- zhaoyue <zhaoyue@uniontech.com>  Fri, 16 Apr 2021 17:04:52 +0800

downloadmanager (5.3.23) stable; urgency=low

  * 修改新建下载任务时，关闭浏览器扩展开关，下载器崩溃的bug

 -- zhaoyue <zhaoyue@uniontech.com>  Wed, 14 Apr 2021 14:51:22 +0800

downloadmanager (5.3.22) stable; urgency=low

  * 修改重启之后正在下载列表显示异常的bug

 -- zhaoyue <zhaoyue@uniontech.com>  Fri, 09 Apr 2021 13:54:45 +0800

downloadmanager (5.3.19) stable; urgency=low

  * 修改帮助手册安装脚本

 -- zhaoyue <zhaoyue@uniontech.com>  Mon, 29 Mar 2021 14:09:50 +0800

downloadmanager (5.3.18) stable; urgency=low

  * 添加帮助手册的安装

 -- zhaoyue <zhaoyue@uniontech.com>  Mon, 29 Mar 2021 11:30:41 +0800

downloadmanager (5.3.17) stable; urgency=low

  * 包里添加下载器的可执行程序



=== debian/control ===
Source: downloadmanager
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: 
 debhelper (>= 12),
 cmake,
 pkg-config,
 libqt5widgets5,
 qtbase5-dev,
 qttools5-dev,
 libqt5network5,
 libqt5webchannel5-dev,
 libqt5websockets5-dev,
 libdtkwidget-dev,
 libdtkgui-dev,
 libdframeworkdbus-dev,
 libgtest-dev,
 libgmock-dev,
 sqlite3,
 aria2,
 curl
Standards-Version: 4.1.3
Homepage: https://www.deepin.org/

Package: org.deepin.downloader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdlmaria2, libdlmcontrolui, libdlmdatabase, libdlmlog
Description: it's a user-friendly download manager, supporting URLs and torrent files.
 downloader for deepin desktop environment.

Package: libdlmaria2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, aria2, curl
Conflicts:
 org.deepin.downloader(<= 5.3.15)
Replaces:
 org.deepin.downloader(<= 5.3.15)
Description: download manager dlmaria2 lib.
 downloader for deepin desktop environment.

Package: libdlmcontrolui
Architecture: any
Conflicts:
 org.deepin.downloader(<= 5.3.15)
Replaces:
 org.deepin.downloader(<= 5.3.15)
Depends: ${shlibs:Depends}, ${misc:Depends}, curl
Description: download manager dlmcontrolui lib.
 downloader for deepin desktop environment.

Package: libdlmdatabase
Architecture: any
Conflicts:
 org.deepin.downloader(<= 5.3.15)
Replaces:
 org.deepin.downloader(<= 5.3.15)
Depends: ${shlibs:Depends}, ${misc:Depends}, sqlite3
Description: download manager dlmdatabase lib.
 downloader for deepin desktop environment.

Package: libdlmlog
Architecture: any
Conflicts:
 org.deepin.downloader(<= 5.3.15)
Replaces:
 org.deepin.downloader(<= 5.3.15)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: download manager dlmlog lib.
 downloader for deepin desktop environment.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=qt5

%:
	dh $@

override_dh_auto_test:
	# Disable auto tests at build time

## downloadmanager 5.3.70

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 #工程名
 project(downloader)
-set(PROJECT_VERSION "5.3.69")
+set(PROJECT_VERSION "5.3.70")
 set(PROJECT_VERSION_MAJOR 5)
 set(QT_MIN_VERSION "5.11.0")
 set(DLM_NAME "downloader")
@@ -105,12 +105,14 @@
 ARCHIVE DESTINATION libstatic
 )
 
+if (USE_AM_DBUS)
+set(SERVICE_SCRIPT docs/dbus/startdlmservice.sh)
+else()
+set(SERVICE_SCRIPT docs/nodbus/startdlmservice.sh)
+endif()
+
 install(DIRECTORY ${APP_RES_DIR}/downloader DESTINATION /usr/share/deepin-manual/manual-assets/application/)
 install(FILES docs/info.json DESTINATION share/downloader/extension/)
 install(FILES docs/ojlicckikdkkaclkpdddijgehekpmmbg.crx DESTINATION share/downloader/extension/)
 install(FILES docs/browser.downloader.autostart.json DESTINATION /etc/browser/native-messaging-hosts/)
-install(FILES docs/startdlmservice.sh DESTINATION /usr/libexec/openconnect/)
-
-
-
-
+install(FILES ${SERVICE_SCRIPT} DESTINATION /usr/libexec/openconnect/)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
 # 设置测试程序名字
 set(PROJECT_NAME_TEST
     ${PROJECT_NAME}_test)
@@ -82,7 +86,7 @@
 
 #添加gtest库，Qt库，dtk库
 target_link_libraries(${PROJECT_NAME_TEST} gmock gmock_main gtest gtest_main pthread
-    Qt5::Core Qt5::Network Qt5::Widgets Qt5::Svg Qt5::DBus Qt5::Sql Qt5::Test dtkwidget dtkgui dtkcore Qt5::WebChannel Qt5::WebSockets)
+    Qt5::Core Qt5::Network Qt5::Widgets Qt5::Svg Qt5::DBus Qt5::Sql Qt5::Test Dtk::Widget Dtk::Gui Dtk::Core Qt5::WebChannel Qt5::WebSockets)
 
 # 添加 QTest 测试
 add_test(${PROJECT_NAME_TEST} COMMAND ${PROJECT_NAME_TEST})

=== src/src/aria2/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
 include_directories(${PROJECT_SOURCE_DIR}/src/include/aria2
                     ${PROJECT_SOURCE_DIR}/src/include/log
                     ${CMAKE_BINARY_DIR}

=== src/src/log/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
 include_directories(${PROJECT_SOURCE_DIR}/src/include/log)
 
 link_directories(${CMAKE_BINARY_DIR}/lib)

=== src/src/ui/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
 #设置包含目录
 include_directories( ${PROJECT_SOURCE_DIR}/src/include/ui
                      ${PROJECT_SOURCE_DIR}/src/include/aria2
@@ -121,8 +125,19 @@
        ${QM_FILES}
 )
 
-target_link_libraries(dlmcontrolui dlmlog dlmaria2 dlmdatabase dtkcore  dtkwidget
-    Qt5::Core Qt5::Network Qt5::Widgets Qt5::Svg Qt5::DBus)
+target_link_libraries(dlmcontrolui 
+    dlmlog
+    dlmaria2
+    dlmdatabase
+    Dtk::Core
+    Dtk::Widget
+    Dtk::Gui
+    Qt5::Core
+    Qt5::Network
+    Qt5::Widgets
+    Qt5::Svg
+    Qt5::DBus
+)
 
 #install(TARGETS dlmcontrolui DESTINATION lib)

=== debian/changelog ===
downloadmanager (5.3.70) stable; urgency=medium

  * 升级版本到5.3.70.

 -- dongpengpeng <dongpengpeng@dongpengpeng>  Thu, 29 Sep 2022 10:46:09 +0800

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,8 @@
 
 Package: org.deepin.downloader
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libdlmaria2, libdlmcontrolui, libdlmdatabase, libdlmlog
+Depends: ${shlibs:Depends}, ${misc:Depends}, libdlmaria2, 
+ libdlmcontrolui, libdlmdatabase, libdlmlog, libglib2.0-bin, dde-application-manager
 Description: it's a user-friendly download manager, supporting URLs and torrent files.
  downloader for deepin desktop environment.

=== debian/rules ===
--- 
+++ 
@@ -7,3 +7,10 @@
 
 override_dh_auto_test:
 	# Disable auto tests at build time
+
+override_dh_auto_configure:
+	dh_auto_configure -- \
+	  -DUSE_AM_DBUS=ON \
+	  -DCMAKE_BUILD_TYPE=Release \
+	  -DCMAKE_INSTALL_PREFIX=/usr \
+      -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib
